Magellan Linux

Diff of /branches/mage-next/src/smage2.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 24 by niro, Wed Jan 5 05:08:01 2005 UTC revision 2365 by niro, Mon Jan 6 12:56:50 2014 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2    # $Id$
3    
4  # compiles/installs .smage2 source install scripts  # compiles/installs .smage2 source install scripts
5  # needs pkgbuild_dir (mage)  # needs pkgbuild_dir (mage)
6    
7  # SMAGE2  # TODO: record dynlib, gz | xz database
 # version: 0.3.6-r8  
8    
9  #01.10.2004  
10  # added ccache support  # set default user mage.rc
11  # added distcc support  : ${MAGERC="/etc/mage.rc"}
12    
13    # export default C locale
14    export LC_ALL=C
15    
16    source /etc/mage.rc.global
17    source ${MAGERC}
18    source ${MLIBDIR}/mage4.functions.sh
19    source ${MLIBDIR}/smage2.functions.sh
20    
21    # export default path
22    export PATH="${PATH}:${MLIBDIR}"
23    
24  ## setup ##  ## setup ##
 SMAGEVERSION=0.3.6-r8  
 PKGSUFFIX="mpk"  
25  SMAGENAME="$1"  SMAGENAME="$1"
26  SMAGESUFFIX="smage2"  SMAGEVERSION="$(< ${MLIBDIR}/version)"
27  #SOURCEDIR="/bootstrap/sources"  
28  #SMAGESCRIPTSDIR="/bootstrap/smage2-install-scripts"  # expand PKGDIR, BUILDDIR and BINDIR with MROOT
29  #SMAGE2RSYNC="rsync://192.168.0.2/smage2-scripts"  if [[ -n ${MROOT} ]]
30  MLIBDIR=/usr/lib/mage  then
31     export PKGDIR=${MROOT}/${PKGDIR}
32  source /etc/mage.rc   export BUILDDIR=${MROOT}/${BUILDDIR}
33     export BINDIR=${MROOT}/${BINDIR}
34  showversion() {  fi
35   echo -en "Magellan Source Install v${SMAGEVERSION} "  
36   echo -e  "-- Niels Rogalla (niro@magellan-linux.de)"  # print out our version
37  }  showversion
38    echo
39  die() {  
40   xtitleclean  if [[ -z ${SMAGENAME} ]]
41   echo "SMAGE failed: $@"  then
42     echo "No .smage2 file given. Exiting."
43     echo
44   exit 1   exit 1
45  }  fi
46    
47    # load supported mage features
48    load_mage_features
49    
50  xtitle() {  # updating smage2-scripts
51   if [ ${TERM} == "xterm" ]  if [[ $1 = update ]]
52    then
53     if [ ! -d ${SOURCEDIR} ]
54   then   then
55   echo -ne "\033]0;[sMage: $@]\007"   install -d ${SOURCEDIR}
56   fi   fi
57   return 0   syncsmage2
58  }   exit 0
59    fi
 xtitleclean() {  
  if [ ${TERM} == "xterm" ]  
  then  
  echo -ne "\033]0;\007"  
  fi  
  return 0  
 }  
   
 syncsmage2() {  
  xtitle "Updating smage2-script tree ..."  
  local i  
  for i in ${SMAGE2RSYNC}  
  do  
  rsync \  
  --recursive \  
  --links \  
  --perms \  
  --times \  
  --devices \  
  --timeout=600 \  
  --verbose \  
  --compress \  
  --progress \  
  --stats \  
  --delete \  
  --delete-after \  
  ${i} ${SMAGESCRIPTSDIR}  
   
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
   
  done  
   
  #clean up backup files (foo~)  
  find ${SMAGESCRIPTSDIR} -name *~ -exec rm '{}' ';'  
   
  xtitleclean  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_prepare() {  
  echo "no src_prepare defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_compile() {  
  echo "no src_compile defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_install() {  
  echo "no src_install defined"  
  sleep 2  
  return 0  
 }  
   
   
 build_mage_script() {  
  return 0  
 }  
   
 mconfigure() {  
  if [ -x ./configure ]  
  then  
  ./configure \  
  --prefix=/usr \  
  --host=${CHOST} \  
  --mandir=/usr/share/man \  
  --infodir=/usr/share/info \  
  --datadir=/usr/share \  
  --sysconfdir=/etc \  
  --localstatedir=/var/lib \  
  "$@" || die "mconfigure failed"  
  else  
  echo "configure is not an executable ..."  
  exit 1  
  fi  
 }  
60    
61  minstall() {  # creates md5sums for smages to given dir
62   if [ -f ./[mM]akefile -o -f ./GNUmakefile ] ; then  if [[ $1 = calcmd5 ]]
63   make prefix=${BINDIR}/usr \  then
64   datadir=${BINDIR}/usr/share \   if [ $# -ge 2 ]
  infodir=${BINDIR}/usr/share/info \  
  localstatedir=${BINDIR}/var/lib \  
  mandir=${BINDIR}/usr/share/man \  
  sysconfdir=${BINDIR}/etc \  
  "$@" install || die "minstall failed"  
         else  
                 die "no Makefile found"  
         fi  
 }  
   
 mmake() {  
  make ${MAKEOPTS} ${EXTRA_EMAKE} "$@"  
 }  
   
 munpack() {  
  local SRCFILE  
  local IFTAR  
  local DEST  
   
  SRCFILE=$1  
   
  if [ -z "$2" ]  
65   then   then
66   DEST=${BUILDDIR}   SMAGENAME="$2"
67   else   MD5DIR="$3"
68   DEST=$2   [[ -z ${MD5DIR} ]] && MD5DIR="$(dirname ${SMAGENAME})/md5"
  fi  
   
  case "${SRCFILE##*.}" in  
  bz2)  
  IFTAR="$(basename $SRCFILE .bz2)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
  then  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  fi  
  ;;  
  gz)  
  IFTAR="$(basename $SRCFILE .gz)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
  then  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  fi  
  ;;  
  tbz2)  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  ;;  
  tgz)  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  ;;  
  *)  
  die "munpack failed"  
  ;;  
  esac  
 }  
   
 mpatch() {  
  local PATCHOPTS  
  local PATCHFILE  
   
  PATCHOPTS=$1  
  PATCHFILE=$2  
   
  patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}  
 }  
   
   
 minstalldocs() {  
  local docfiles  
   
  docfiles="$@"  
   
  if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]  
  then  
  install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."  
  fi  
   
  for i in ${docfiles}  
  do  
  cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."  
  install -m 0644 ${SRCDIR}/${i}.gz \  
  ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."  
  done  
 }  
   
 setup_distcc_environment(){  
  if [ -x /usr/bin/distcc ]  
  then  
  echo "Using DistCC for compilation ..."  
  export PATH=/usr/lib/distcc/bin:${PATH} || die "distcc: could not export new $PATH"  
   
  #export distcc as compiler  
 # export CC="distcc"  
 # export CXX=distcc  
69    
70   export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"   smagesource ${SMAGENAME} || die "download source failed"
71    
72     # overridable sourcedir; must be declared after source of the smage2
73     CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"
74    
75   #ccache + distcc together   [ -z "${SRC_URI}" ] && die "Nothing declared to calculate."
76   if [ "${SMAGE_USE_CCACHE}" == "true" ]  
77   then   # end of array
78   if [ -x /usr/bin/ccache ]   EOA=${#SRC_URI[*]}
79    
80     [ ! -d ${MD5DIR} ] && install -d ${MD5DIR}
81    
82     # clear md5sum file
83     MY_MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"
84     echo -n > ${MY_MD5_FILE}
85    
86     for ((i=0; i < EOA; i++))
87     do
88     # url to file
89     my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"
90    
91     # subdir in sources dir; the my_SRCI_URI file goes to there
92     my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"
93    
94     # if my_src_uri_dest is not equal my_src_uri; than an other dir is used
95     if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]
96   then   then
97   echo "Preparing DistCC to work together with CCache ..."   MY_SRC_FILE="${my_SRC_URI_DEST}/$(basename ${SRC_URI[${i}]})"
98   #export CCACHE_PREFIX="distcc" || die "distcc: could not set ccach_prefix"   else
99  # export CC="ccache distcc"   MY_SRC_FILE="$(basename ${SRC_URI[${i}]})"
 # export CXX="ccache distcc"  
100   fi   fi
  fi  
101    
102   #creating distcc tempdir   if [ -e "${CALC_SOURCEDIR}/${MY_SRC_FILE}" ]
103   install -o distcc -g daemon -d ${DISTCC_DIR}   then
104   chmod 1777 ${DISTCC_DIR}   echo "calculating $(basename ${MY_SRC_FILE}) ..."
105   fi   ( cd ${CALC_SOURCEDIR}; md5sum "${MY_SRC_FILE}" ) >> ${MY_MD5_FILE}
106  }   else
107     echo "WARNING: File '$(basename ${MY_SRC_FILE}) not found in ${CALC_SOURCEDIR}."
108  setup_ccache_environment(){   fi
109   if [ -x /usr/bin/ccache ]  
110   then   # unset them to be shure
111   echo "Using CCache for compilation ..."   unset my_SRC_URI
112   export PATH=/usr/lib/ccache/bin:${PATH} || die "ccache: could not export new $PATH"   unset my_SRC_URI_DEST
113   #unset CC CXX   unset my_SRC_URI_MIRROR
114     unset my_SOURCEDIR
115     done
116    
117     echo
118     echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."
119     echo
120     else
121     echo "Usage: Calculating MD5 Sums:"
122     echo "    $(basename $0) calcmd5 /path/to/SMAGENAME [/path/to/MD5DIR]"
123     echo
124     echo
125     echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."
126     echo
127     exit 1
128   fi   fi
 }  
129    
130  if [ -z "$1" ]   exit 0
 then  
  showversion  
  echo  
  echo "No .smage2 file given. Exiting."  
  echo  
  exit 1  
131  fi  fi
132    
133  #updating smage2-scripts  # download sources
134  if [ "$1" == "update" ]  if [ "$1" == "download" -a -n "$2" ]
135  then  then
  showversion  
136   if [ ! -d ${SMAGESCRIPTSDIR} ]   if [ ! -d ${SMAGESCRIPTSDIR} ]
137   then   then
138   install -d ${SMAGESCRIPTSDIR}   install -d ${SMAGESCRIPTSDIR}
139   fi   fi
  syncsmage2  
  exit 0  
 fi  
140    
141     # get smage
142     SMAGENAME="$2"
143     MD5DIR="$(dirname ${SMAGENAME})/md5"
144     smagesource ${SMAGENAME} || die "download source failed"
145    
146  if [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ]   download_sources
147  then   exit 0
  die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."  
148  fi  fi
149    
150  if [ -z "`basename ${SMAGENAME}|grep .${SMAGESUFFIX}`" ]  # regen-mage-tree
151    if [ "$1" == "only-regen-tree" -a -n "$2" ]
152  then  then
153   die "File '`basename ${SMAGENAME}`' is not a sMage v${SMAGEVERSION} file. Aborting."   # set correct SMAGENAME
154  fi   SMAGENAME="$2"
155     MD5DIR="$(dirname ${SMAGENAME})/md5"
156     smagesource ${SMAGENAME} || die "regen: smage2 not found"
157    
158  if [ -z "${SOURCEDIR}" ]   regen_mage_tree
 then  
  die "\$SOURCEDIR not found. Please setup your mage.rc correctly."  
 fi  
159    
160  if [ -z "${SMAGESCRIPTSDIR}" ]   # build several subpackages
161  then   if [[ -n ${SPLIT_PACKAGES} ]]
162   die "\$SMAGESCRIPTSDIR not found. Please setup your mage.rc correctly."   then
163  fi   split_save_variables
164     for subpackage in ${SPLIT_PACKAGES}
165     do
166     # get the right variables for the split
167     export PNAME="${subpackage}"
168     split_info_${subpackage}
169     # fix PCATEGORIE -> PCAT
170     if [[ ! -z ${PCATEGORIE} ]]
171     then
172     PCAT="${PCATEGORIE}"
173     unset PCATEGORIE
174     fi
175     # build md5sum for existing packages
176     generate_package_md5sum \
177     --pcat "${PCAT}" \
178     --pname "${PNAME}" \
179     --pver "${PVER}" \
180     --pbuild "${PBUILD}" \
181     --parch "${ARCH}"
182     # restore smage environment
183     split_restore_variables
184     done
185     # unset all saved smage variables
186     split_unset_variables
187    
188  if [ -z "${SMAGE2RSYNC}" ]   else
189  then   # build md5sum for existing packages
190   echo "\$SMAGE2RSYNC not found. Please setup your mage.rc correctly."   generate_package_md5sum \
191   exit 1   --pcat "${PCAT}" \
192  fi   --pname "${PNAME}" \
193     --pver "${PVER}" \
194     --pbuild "${PBUILD}" \
195     --parch "${ARCH}"
196     fi
197    
198  if [ -z "${BINDIR}" ]   exit 0
 then  
  die "no BINDIR variable found in /etc/mage.rc"  
199  fi  fi
200    
201  if [ -z "${CHOST}" ]  if [ "$1" == "--create-src-tarball" -a -n "$2" ]
202  then  then
203   die "no CHOST variable found in /etc/mage.rc"   # set correct SMAGENAME
204     SMAGENAME="$2"
205     MD5DIR="$(dirname ${SMAGENAME})/md5"
206    
207     echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"
208    
209     smagesource ${SMAGENAME} || die "regen: smage2 not found"
210    
211     if [[ -d ${SOURCEDIR}/${PNAME} ]]
212     then
213     echo -e "${COLGREEN}Deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
214     rm -rf ${SOURCEDIR}/${PKGNAME}
215     fi
216    
217     download_sources
218     source_pkg_build ${SMAGENAME}
219     exit 0
220  fi  fi
221    
222  if [ -z "${CFLAGS}" ]  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
223  then  then
224   die "no CFLAGS variable found in /etc/mage.rc"   SRCPKGTARBALL="${2}"
225     msetfeature "srcpkgtarball"
226    
227     # abort if given file is not a source pkg
228     [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
229    
230     # set correct SMAGENAME; use the one that the src_pkg provide
231     # /path/to/SOURCEDIR/PNAME/SMAGENAME
232     SMAGENAME="${SOURCEDIR}/$(basename ${SRCPKGTARBALL%-*-*})/$(basename ${SRCPKGTARBALL} .${SRCPKGSUFFIX}).${SMAGESUFFIX}"
233    
234     echo -e "${COLGREEN}Using src-tarball ${COLBLUE}${SRCPKGTARBALL}${COLGREEN} ...${COLDEFAULT}"
235    
236     [[ ! -d ${SOURCEDIR} ]] && install -d ${SOURCEDIR}
237    
238     # unpack srctarball
239     [[ ! -f ${SRCPKGTARBALL} ]] && die "Error: ${SRCPKGTARBALL} does not exist. Aborting."
240    
241     tar xvjf ${SRCPKGTARBALL} -C ${SOURCEDIR} || die  "Error unpackung src-tarball ${SRCPKGTARBALL}"
242    
243     [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"
244  fi  fi
245    
246  if [ -z "${CXXFLAGS}" ]  if [ "$1" == "--resume" -a -n "$2" ]
247  then  then
248   die "no CXXFLAGS variable found in /etc/mage.rc"   msetfeature "resume"
249     SMAGENAME="$2"
250  fi  fi
251    
252    [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."
253    [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&
254     die "File '$(basename ${SMAGENAME})' is not a sMage v${SMAGEVERSION} file. Aborting."
255    [ -z "${SOURCEDIR}" ] && die "\$SOURCEDIR not found. Please setup your ${MAGERC} correctly."
256    [ -z "${SMAGESCRIPTSDIR}" ] && die "\$SMAGESCRIPTSDIR not found. Please setup your ${MAGERC} correctly."
257    [ -z "${SMAGE2RSYNC}" ] && die "\$SMAGE2RSYNC not found. Please setup your ${MAGERC} correctly."
258    [ -z "${BINDIR}" ] && die "no BINDIR variable found in ${MAGERC}"
259    [ -z "${CHOST}" ] && die "no CHOST variable found in ${MAGERC}"
260    [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"
261    [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
262    
263  source ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
264  PKGNAME="${PNAME}-${PVER}-${CHOST%%-*}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}"
265    MD5DIR="$(dirname ${SMAGENAME})/md5"
266    SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"
267    
268  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
269  #fixes some issues with these functions  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"
270    
271    # auto regen mage tree if requested
272    regen_mage_tree
273    
274    if mqueryfeature "srcpkgbuild"
275    then
276     if [[ -d ${SOURCEDIR}/${PNAME} ]]
277     then
278     echo -e "${COLBLUE}===${COLGREEN} deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
279     rm -rf ${SOURCEDIR}/${PNAME}
280     fi
281    fi
282    
283    # download sources
284    mqueryfeature "srcpkgtarball" || download_sources
285    
286    # fixes some issues with these functions
287  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
288  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
289    export -f src_check || die "src_check export failed"
290  export -f src_install || die "src_install export failed"  export -f src_install || die "src_install export failed"
291    
292  #fixes some compile issues  # fixes some compile issues
293  export CHOST="${CHOST}" || die "CHOST export failed"  export CHOST="${CHOST}" || die "CHOST export failed"
294  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"
295  export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"  if [[ -z ${CXXFLAGS} ]]
296    then
297     export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"
298    else
299     export CXXFLAGS="${CXXFLAGS}" || die "CXXFLAGS export failed"
300    fi
301    export LDFLAGS="${LDFLAGS}" || die "LDFLAGS export failed"
302  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
303  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
304    
305    # setup distcc
306    # setup for distcc goes *before* ccache, so ccache comes before distcc in path
307    mqueryfeature "distcc" && setup_distcc_environment
308    
309  #setup distcc  # setup icecc
310  #distcc mus be setup *before* ccache, as ccache need to be before distcc in path  # setup for icecc goes *before* ccache, so ccache comes before icecc in path
311  if [ "${SMAGE_USE_DISTCC}" == "true" ]  mqueryfeature "icecc" && setup_icecc_environment
312  then  
313   setup_distcc_environment  # setup ccache
314  fi  mqueryfeature "ccache" && setup_ccache_environment
315    
316  #setup ccache  if mqueryfeature "resume"
 if [ "${SMAGE_USE_CCACHE}" == "true" ]  
317  then  then
318   setup_ccache_environment   echo -e "${COLMAGENTA}Resume requested; continuing previous build${COLDEFAULT}"
 fi  
319    
320     # setup build logging
321     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
322     if [[ -f /var/log/smage/${PKGNAME}.log.bz2 ]]
323     then
324     bunzip2 -f /var/log/smage/${PKGNAME}.log.bz2
325     fi
326     echo -e "### Resume started on $(date) ###\n" >> /var/log/smage/${PKGNAME}.log
327    
328  # small sleep to show our settings  else
329  sleep 1   # clean up builddir if a previously one exist
330     if [ -d ${BUILDDIR} ]
331     then
332     rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
333     fi
334     install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
335    
336  #debug   # clean up srcdir if a previously unpacked one exist
337  #echo "CC=${CC}"   if [ -d ${SRCDIR} ]
338  #echo "CXX=${CXX}"   then
339  #echo "DISTCC_DIR=${DISTCC_DIR}"   rm -rf ${SRCDIR}
340  #echo "PATH: ${PATH}"   fi
 #echo "--------------------------------------"  
 #env  
 #echo "--------------------------------------"  
 #read  
 #debug end  
341    
342  #cleans up build if a previously one exists   # clean up bindir if a previous build exist or create a new one
343  if [ -d ${BUILDDIR} ]   if [ -d ${BINDIR} ]
344  then   then
345   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   rm -rf ${BINDIR}
346     fi
347     install -d ${BINDIR} || die "couldn't create \$BINDIR."
348    
349     # clean up package temp dir if a previous build exist
350     if [ -d ${BUILDDIR}/${PKGNAME} ]
351     then
352     rm -rf ${BUILDDIR}/${PKGNAME}
353     fi
354    
355     # clean up stamps dir
356     if [ -d ${BUILDDIR}/.stamps ]
357     then
358     rm -rf ${BUILDDIR}/.stamps
359     fi
360    
361     # setup build logging
362     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
363     echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log
364    fi
365    
366    if [[ ${PKGTYPE} = virtual ]]
367    then
368     echo "virtual package detected; nothing will be build ..."
369     # automatically set !pkgbuild here too
370     msetfeature "!pkgbuild"
371    else
372     ( run_resume src_prepare || src_prepare ) | ${SMAGE_LOG_CMD}
373     die_pipestatus 0 "src_prepare failed"
374     resume_stamp src_prepare
375     step_by_step src_prepare
376    
377     ( run_resume src_compile || src_compile ) | ${SMAGE_LOG_CMD}
378     die_pipestatus 0 "src_compile failed"
379     resume_stamp src_compile
380     step_by_step src_compile
381    
382     # only run checks if requested
383     if mqueryfeature "!check"
384     then
385     echo "!check detected; src_check() will not be run!" | ${SMAGE_LOG_CMD}
386     else
387     ( run_resume src_check || src_check ) | ${SMAGE_LOG_CMD}
388     die_pipestatus 0 "src_check failed"
389     resume_stamp src_check
390     fi
391     step_by_step src_check
392    
393     # build several subpackages
394     if [[ -n ${SPLIT_PACKAGES} ]]
395     then
396     # save bindir & pname
397     split_save_variables
398     export SAVED_BINDIR="${BINDIR}"
399     for subpackage in ${SPLIT_PACKAGES}
400     do
401     split_info_${subpackage}
402     if [[ ${PKGTYPE} = virtual ]]
403     then
404     echo
405     echo -en "${COLBLUE}*** ${COLDEFAULT}"
406     echo -en "Virtual package detected"
407     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
408     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
409    
410     echo "virtual package detected; nothing will be build ..."
411     # automatically set !pkgbuild here too
412     msetfeature "!pkgbuild"
413     else
414     if typeset -f src_install_${subpackage} > /dev/null
415     then
416     # export subpackage bindir
417     export BINDIR="${SAVED_BINDIR}_${subpackage}"
418     # export PNAME, several internal function and include
419     # rely on this variable
420     export PNAME="${subpackage}"
421    
422     echo
423     echo -en "${COLBLUE}*** ${COLDEFAULT}"
424     echo -en "Running ${COLGREEN}split src_install()${COLDEFAULT}"
425     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
426     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
427    
428     ( run_resume src_install_${subpackage} || src_install_${subpackage} ) | ${SMAGE_LOG_CMD}
429     die_pipestatus 0 "src_install_${subpackage} failed"
430     resume_stamp src_install_${subpackage}
431     step_by_step src_install_${subpackage}
432     fi
433     fi
434     # restore smage environment
435     split_restore_variables
436     done
437     # unset all saved smage variables
438     split_unset_variables
439     else
440     ( run_resume src_install || src_install ) | ${SMAGE_LOG_CMD}
441     die_pipestatus 0 "src_install failed"
442     resume_stamp src_install
443     step_by_step src_install
444     fi
445  fi  fi
 install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  
446    
447  #cleans up srcdir if a previously unpacked one exists  # echo for sake of good-looking
448  if [ -d ${SRCDIR} ]  echo
449    
450    if mqueryfeature "!compressdoc"
451    then
452     echo -e "!compressdoc detected; documentation will not be compressed ..."
453    elif mqueryfeature "!pkgbuild"
454  then  then
455   rm -rf ${SRCDIR}   echo "!pkgbuild detected; skipping documentation compression..."
456    else
457     # compressing doc, info & man files
458     if [[ -n ${SPLIT_PACKAGES} ]]
459     then
460     # save smage environment
461     split_save_variables
462     for subpackage in ${SPLIT_PACKAGES}
463     do
464     # honor split_info
465     split_info_${subpackage}
466     if [[ ${PKGTYPE} = virtual ]]
467     then
468     # automatically set !pkgbuild here too
469     msetfeature "!pkgbuild"
470     fi
471    
472     if mqueryfeature "!compressdoc"
473     then
474     echo -e "!compressdoc detected; documentation of '${subpackage}' will not be compressed ..."
475     elif mqueryfeature "!pkgbuild"
476     then
477     echo "!pkgbuild detected; skipping documentation compression for '${subpackage}' ..."
478     else
479     run_resume post-mcompressdoc_${subpackage} || mcompressdocs ${BINDIR}_${subpackage}
480     resume_stamp post-mcompressdoc_${subpackage}
481     fi
482     # restore smage environment
483     split_restore_variables
484     done
485     # unset saved variables
486     split_unset_variables
487     else
488     run_resume post-mcompressdoc || mcompressdocs ${BINDIR}
489     resume_stamp post-mcompressdoc
490     fi
491  fi  fi
492    
493  #cleans up bindir if a previous build exists or creates a new one  if mqueryfeature "!libtool"
 if [ -d ${BINDIR} ]  
494  then  then
495   rm -rf ${BINDIR}   if mqueryfeature "!pkgbuild"
496     then
497     echo "!pkgbuild detected; skipping libtool archive stripping ..."
498     else
499     if [[ -n ${SPLIT_PACKAGES} ]]
500     then
501     # save smage environment
502     split_save_variables
503     for subpackage in ${SPLIT_PACKAGES}
504     do
505     # honor split_info
506     split_info_${subpackage}
507     if [[ ${PKGTYPE} = virtual ]]
508     then
509     # automatically set !pkgbuild here too
510     msetfeature "!pkgbuild"
511     fi
512    
513     if mqueryfeature "!libtool"
514     then
515     if mqueryfeature "!pkgbuild"
516     then
517     echo "!pkgbuild detected; skipping libtool archive stripping for '${subpackage}'..."
518     else
519     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
520     run_resume post-mstriplibtoolarchive_${subpackage} || mstriplibtoolarchive ${BINDIR}_${subpackage}
521     resume_stamp post-mstriplibtoolarchive_${subpackage}
522     fi
523     fi
524    
525     # restore smage environment
526     split_restore_variables
527     done
528     # unset saved variables
529     split_unset_variables
530     else
531     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
532     run_resume post-mstriplibtoolarchive || mstriplibtoolarchive ${BINDIR}
533     resume_stamp post-mstriplibtoolarchive
534     fi
535     fi
536  fi  fi
 install -d ${BINDIR} || die "couldn't create \$BINDIR."  
537    
538  #cleans up package temp dir if a previous build exists  if mqueryfeature "purge"
 if [ -d ${BUILDDIR}/${PKGNAME} ]  
539  then  then
540   rm -rf ${BUILDDIR}/${PKGNAME}   if mqueryfeature "!pkgbuild"
541     then
542     echo "!pkgbuild detected; skipping file purgation ..."
543     else
544     if [[ -n ${SPLIT_PACKAGES} ]]
545     then
546     # save smage environment
547     split_save_variables
548     for subpackage in ${SPLIT_PACKAGES}
549     do
550     # honor split_info
551     split_info_${subpackage}
552     if [[ ${PKGTYPE} = virtual ]]
553     then
554     # automatically set !pkgbuild here too
555     msetfeature "!pkgbuild"
556     fi
557    
558     if mqueryfeature "purge"
559     then
560     if mqueryfeature "!pkgbuild"
561     then
562     echo "!pkgbuild detected; skipping file purgation for '${subpackage}' ..."
563     else
564     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
565     run_resume post-mpurgetargets_${subpackage} || mpurgetargets ${BINDIR}_${subpackage}
566     resume_stamp post-mpurgetargets_${subpackage}
567     fi
568     fi
569    
570     # restore smage environment
571     split_restore_variables
572     done
573     # unset saved variables
574     split_unset_variables
575     else
576     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
577     run_resume post-mpurgetargets || mpurgetargets ${BINDIR}
578     resume_stamp post-mpurgetargets
579     fi
580     fi
581  fi  fi
582    
583  #cleans up timestamp if one exists  # stripping all bins and libs
584  if [ -f /var/tmp/timestamp ]  if mqueryfeature "!strip"
585  then  then
586   mage rmstamp   echo -e "!strip detected; package will not be stripped ..."
587  fi  elif mqueryfeature "!pkgbuild"
588    then
589     echo "!pkgbuild detected; skipping stripping of the package ..."
590    else
591     if [[ -n ${SPLIT_PACKAGES} ]]
592     then
593     # save smage environment
594     split_save_variables
595     for subpackage in ${SPLIT_PACKAGES}
596     do
597     # honor split_info
598     split_info_${subpackage}
599     if [[ ${PKGTYPE} = virtual ]]
600     then
601     # automatically set !pkgbuild here too
602     msetfeature "!pkgbuild"
603     fi
604    
605  src_prepare || die "src_prepare failed"   if mqueryfeature "!strip"
606  src_compile || die "src_compile failed"   then
607  src_install || die "src_install failed"   echo -e "!strip detected; package '${subpackage}' will not be stripped ..."
608     elif mqueryfeature "!pkgbuild"
609     then
610     echo "!pkgbuild detected; skipping stripping of the package '${subpackage}' ..."
611     else
612     echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
613     run_resume post-mstripbins_${subpackage} || mstripbins ${BINDIR}_${subpackage}
614     resume_stamp post-mstripbins_${subpackage}
615     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
616     run_resume post-mstriplibs_${subpackage} || mstriplibs ${BINDIR}_${subpackage}
617     resume_stamp post-mstriplibs_${subpackage}
618     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
619     run_resume post-mstripstatic_${subpackage} || mstripstatic ${BINDIR}_${subpackage}
620     resume_stamp post-mstripstatic_${subpackage}
621     fi
622    
623     # restore smage environment
624     split_restore_variables
625     done
626     # unset saved variables
627     split_unset_variables
628     else
629     echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
630     run_resume post-mstripbins || mstripbins ${BINDIR}
631     resume_stamp post-mstripbins
632     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
633     run_resume post-mstriplibs || mstriplibs ${BINDIR}
634     resume_stamp post-mstriplibs
635     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
636     run_resume post-mstripstatic || mstripstatic ${BINDIR}
637     resume_stamp post-mstripstatic
638     fi
639    fi
640    
641  #compressing doc, info & man files  if mqueryfeature "qalint"
 echo -e "Compressing man-pages ..."  
 if [ -d ${BUILDDIR}/builded/usr/share/man ]  
642  then  then
643   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/man   if mqueryfeature "!pkgbuild"
644     then
645     echo "!pkgbuild detected; skipping QA lint checks ..."
646     else
647     if [[ -n ${SPLIT_PACKAGES} ]]
648     then
649     # save smage environment
650     split_save_variables
651     for subpackage in ${SPLIT_PACKAGES}
652     do
653     # honor split_info
654     split_info_${subpackage}
655     if [[ ${PKGTYPE} = virtual ]]
656     then
657     # automatically set !pkgbuild here too
658     msetfeature "!pkgbuild"
659     fi
660    
661     if mqueryfeature "qalint"
662     then
663     if mqueryfeature "!pkgbuild"
664     then
665     echo "!pkgbuild detected; skipping QA lint checks for '${subpackage}' ..."
666     else
667     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks for '${subpackage}' ...${COLDEFAULT}"
668     mqalint ${BINDIR}_${subpackage}
669     fi
670     fi
671    
672     # restore smage environment
673     split_restore_variables
674     done
675     # unset saved variables
676     split_unset_variables
677     else
678     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks ...${COLDEFAULT}"
679     mqalint ${BINDIR}
680     fi
681     fi
682  fi  fi
683    
684  echo -e "Compressing info-pages ..."  if mqueryfeature "!pkgbuild"
 if [ -d ${BUILDDIR}/builded/usr/share/info ]  
685  then  then
686   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info   echo -e "!pkgbuild detected; Package will not be build ..."
687    else
688     # build several subpackages
689     if [[ -n ${SPLIT_PACKAGES} ]]
690     then
691     split_save_variables
692     for subpackage in ${SPLIT_PACKAGES}
693     do
694     # get the right variables for the split
695     export PNAME="${subpackage}"
696     split_info_${PNAME}
697     # fix PCATEGORIE -> PCAT
698     if [[ ! -z ${PCATEGORIE} ]]
699     then
700     PCAT="${PCATEGORIE}"
701     unset PCATEGORIE
702     fi
703     if [[ ${PKGTYPE} = virtual ]]
704     then
705     # automatically set !pkgbuild here too
706     msetfeature "!pkgbuild"
707     fi
708    
709     # jump to next one if !pkgbuild is set in split_info
710     if mqueryfeature "!pkgbuild"
711     then
712     # restore smage environment
713     split_restore_variables
714     continue
715     fi
716    
717     # check if an special subpackage_pkgbuild exists
718     if typeset -f ${PNAME}_pkgbuild > /dev/null
719     then
720     # run it
721     run_resume post-${PNAME}_pkgbuild || ${PNAME}_pkgbuild
722     resume_stamp post-${PNAME}_pkgbuild
723     fi
724     # now create the target package
725     run_resume post-pkg_builddir_${PNAME} || ${MLIBDIR}/pkgbuild_dir.sh \
726     "${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
727     "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
728     resume_stamp post-pkg_builddir_${PNAME}
729    
730     # build pkg-md5-sum if requested
731     run_resume post-md5sum_${PNAME} || generate_package_md5sum \
732     --pcat "${PCAT}" \
733     --pname "${PNAME}" \
734     --pver "${PVER}" \
735     --pbuild "${PBUILD}" \
736     --parch "${ARCH}"
737     resume_stamp post-md5sum_${PNAME}
738    
739     echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
740    
741     # restore smage environment
742     split_restore_variables
743     done
744     # unset all saved smage variables
745     split_unset_variables
746    
747     else
748     run_resume post-pkg_builddir || ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"
749     resume_stamp post-pkg_builddir
750    
751     # build pkg-md5-sum if requested
752     run_resume post-md5sum || generate_package_md5sum \
753     --pcat "${PCAT}" \
754     --pname "${PNAME}" \
755     --pver "${PVER}" \
756     --pbuild "${PBUILD}" \
757     --parch "${ARCH}"
758     resume_stamp post-md5sum
759    
760     echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"
761     fi
762    
763     # build src-pkg-tarball if requested
764     if mqueryfeature "srcpkgbuild"
765     then
766     run_resume post-srcpkgbuild || source_pkg_build ${SMAGENAME}
767     resume_stamp post-srcpkgbuild
768     fi
769  fi  fi
770    
771  #the new buildpkg command  if mqueryfeature "buildlog"
772  case ${NOPKGBUILD} in  then
773   true|TRUE|yes|y)   bzip2 -9f /var/log/smage/${PKGNAME}.log
774   echo -e "NOPGKBUILD=true detected; Package will not be build ..."  else
775   ;;   [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log
776   *)  fi
  ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"  
  echo -e "\nPackage ${PKGNAME} successfully builded.\n"  
  ;;  
 esac  
777    
 #for sure  
 unset NOPKGBUILD  
   
778  xtitleclean  xtitleclean
 #echo -e "\nPackage ${PKGNAME} successfully builded.\n"  

Legend:
Removed from v.24  
changed lines
  Added in v.2365